package greedy;
/**
 * 题目： 122. 买卖股票的最佳时机 II (maxProfit)
 * 描述：给你一个整数数组 prices ，其中 prices[i] 表示某支股票第 i 天的价格。
 * 在每一天，你可以决定是否购买和/或出售股票。你在任何时候 最多 只能持有 一股 股票。你也可以先购买，然后在 同一天 出售。
 * 返回 你能获得的 最大 利润 。

 * 示例 1：
 输入：prices = [7,1,5,3,6,4]
 输出：7
 解释：在第 2 天（股票价格 = 1）的时候买入，在第 3 天（股票价格 = 5）的时候卖出, 这笔交易所能获得利润 = 5 - 1 = 4。
 随后，在第 4 天（股票价格 = 3）的时候买入，在第 5 天（股票价格 = 6）的时候卖出, 这笔交易所能获得利润 = 6 - 3 = 3。
 最大总利润为 4 + 3 = 7 。

 * 链接：https://leetcode.cn/problems/best-time-to-buy-and-sell-stock-ii/
 */
//考虑复杂了！
public class MaxProfit2 {
    public int maxProfit1(int[] prices) {
        int prediff=0,curdiff=0,maxprofit=0,buyprice=0;
        boolean flag=false;
        for (int i = 1; i < prices.length; i++) {
            curdiff=prices[i]-prices[i-1];
            if(!flag){
                if(prediff<=0 &&curdiff>0){
                    flag=true;
                    buyprice=prices[i-1];
                }
            }else {
                if(prediff>=0&&curdiff<0){
                    flag=false;
                    maxprofit+=prices[i-1]-buyprice;
                }
            }
            prediff=curdiff;
        }
        if(flag)
            maxprofit+=prices[prices.length-1]-buyprice;
        return maxprofit;
    }
    //收集正利润的区间，就是股票买卖的区间，而我们只需要关注最终利润，不需要记录区间。
    public int maxProfit(int[] prices) {
        int result = 0;
        for (int i = 1; i < prices.length; i++) {
            result += Math.max(prices[i] - prices[i - 1], 0);
        }
        return result;
    }
}
